

#ifndef  __KEYPAD_H__
#define  __KEYPAD_H__


#include <stdint.h>
#include "StaticQueue.H"
#include "RandomNumberGenerator.H"


extern "C++" {
	namespace avelino {
		using namespace std;

		class Keypad : public BooleanEntropySource {
			protected:
				enum class Status { IDLE, WAIT_AFTER_PRESS, WAIT_UNTIL_RELEASE, WAIT_AFTER_RELEASE };
				Status status;
				uint16_t waitCounter;
				static const uint16_t WAIT_COUNTER_MAX_AFTER_PRESS = 10;
				static const uint16_t WAIT_COUNTER_MAX_AFTER_RELEASE = 10;
				uint16_t lastMask;
			public:
				uint16_t mask;
				StaticQueue<uint16_t, 16> keyQueue;
				void init();
				void onVBlank();
				virtual bool getEntropyValue();
		};
	}
}


#endif  // __KEYPAD_H__
