

#include "Keypad.H"
#include "gba.H"


using namespace std;
using namespace avelino;


void Keypad::init() {
	this->keyQueue.init();
	this->status = Status::IDLE;
	this->mask = 0;
}


void Keypad::onVBlank() {
	uint16_t k = KEYINPUT;
	if (this->status == Status::IDLE) {
		this->mask = (~k) & 0x03FF;
		if (this->mask != 0) {
			this->keyQueue.push(this->mask);
			this->waitCounter = WAIT_COUNTER_MAX_AFTER_PRESS;
			this->status = Status::WAIT_AFTER_PRESS;
		}
	}
	else if (this->status == Status::WAIT_AFTER_PRESS) {
		this->waitCounter--;
		if (this->waitCounter == 0) {
			//this->status = Status::IDLE;
			this->status = Status::WAIT_UNTIL_RELEASE;
		}
	}
	else if (this->status == Status::WAIT_UNTIL_RELEASE) {
		uint16_t aux = (~k) & 0x03FF;
		if (aux == 0) {
			this->waitCounter = WAIT_COUNTER_MAX_AFTER_RELEASE;
			this->status = Status::WAIT_AFTER_RELEASE;
		}
	}
	else if (this->status == Status::WAIT_AFTER_RELEASE) {
		this->waitCounter--;
		if (this->waitCounter == 0)
			this->status = Status::IDLE;
	}
}


bool Keypad::getEntropyValue() {
	return (this->mask != 0);
}

