

#ifndef  __LEVEL_H__
#define  __LEVEL_H__


#include <stdint.h>


extern "C++" {
	namespace avelino {
		using namespace std;

		class Level {
			public:
				char shortName[3];
				static const uint16_t NAME_SIZE = 10;
				char name[NAME_SIZE];
				static const uint16_t BOARD_WIDTH = 9;
				static const uint16_t BOARD_HEIGHT = 9;
				static const uint16_t BOARD_SIZE = BOARD_WIDTH * BOARD_HEIGHT;
				uint16_t boardTiles[BOARD_SIZE];
				// each board tile:    15  14  13  12  11 10  9  8  7  6  5  4  3  2  1  0
				//                     |                         |  P  D2 D1 D0    B0 B1 B0
				//                     +------------+------------+  |     |           |
				//                                  |               |     |           +--- block here (1..7) or empty tile (0)
				//                                  |               |     +--------------- finish for block (1..7) or empty tile (0)
				//                                  |               +--------------------- 0 is passable, 1 is not passable
				//                                  +------------------------------------- reserved (for special features)
				uint16_t totalMinutes;
				uint16_t totalSeconds;
				static const uint16_t MAX_LEVELS_TO_UNLOCK = 8;
				static const uint16_t NULL_LEVEL = 0xFF;
				uint8_t levelsToUnlock[MAX_LEVELS_TO_UNLOCK];
		};

		class LevelManager {
			public:
				static const uint16_t NUM_LEVELS = 32;
				static const Level LEVELS[NUM_LEVELS];
		};
	}
}


#endif  // __LEVEL_H__
