

#ifndef  __PATHMANAGER_H__
#define  __PATHMANAGER_H__


#include <stdint.h>
#include <stdlib.h>


extern "C++" {
	namespace avelino {
		using namespace std;

		class PathPoint {
			public:
				int32_t x;
				int32_t y;
		};


		class PathManager;


		class PathListener {
			public:
				virtual void updatePath(PathManager &source, const PathPoint &point) = 0;
		};


		class PathManager {
			protected:
				const PathPoint *pathPoints;
				const PathPoint *nextPoint;
				uint16_t numPathPoints;
				uint16_t i;
				uint32_t delay;
				uint32_t counter;
				PathListener *listener;
				enum class Status { IDLE, RUNNING };
				Status status;
			public:
				PathManager() : listener(NULL), status(Status::IDLE) { };
				void init(const PathPoint *pathPoints, uint16_t numPathPoints, uint32_t delay, PathListener &listener);
				void onVBlank();
		};
	}
}


#endif  // __PATHMANAGER_H__
