

#include "PathManager.H"


using namespace avelino;
using namespace std;


void PathManager::init(const PathPoint *pathPoints, uint16_t numPathPoints, uint32_t delay, PathListener &listener) {
	this->pathPoints = pathPoints;
	this->numPathPoints = numPathPoints;
	this->i = 0;
	this->delay = delay;
	this->listener = &listener;
	this->status = Status::RUNNING;
	this->nextPoint = this->pathPoints;
	this->counter = 1;
}


void PathManager::onVBlank() {
	if (this->status == Status::IDLE) {
		//
	}
	else if (this->status == Status::RUNNING) {
		this->counter--;
		if (this->counter == 0) {
			this->listener->updatePath(*this, *this->nextPoint);
			this->i++;
			if (this->i == this->numPathPoints) {
				this->nextPoint = this->pathPoints;
				this->i = 0;
			}
			else
				this->nextPoint++;
			this->counter = this->delay;
		}
	}
}

