

#ifndef  __RANDOMNUMBERGENERATOR_H__
#define  __RANDOMNUMBERGENERATOR_H__


#include <stdint.h>
#include "LFSR.H"


extern "C++" {
	namespace avelino {
		using namespace std;

		class BooleanEntropySource {
			public:
				virtual bool getEntropyValue() = 0;
		};

		class RandomNumberGenerator {
			protected:
				LFSR lfsr;
				enum class Status : uint8_t { WAIT_FOR_ENTROPY_1, WAIT_FOR_ENTROPY_2, IDLE };
				Status status;
				uint32_t counter;
				uint16_t seed;
			public:
				void init(uint16_t seed);
				void onVBlank(BooleanEntropySource &es);
				uint16_t getValue();
		};
	}
}


#endif  // __RANDOMNUMBERGENERATOR_H__
