

#include "RandomNumberGenerator.H"


using namespace std;
using namespace avelino;


void RandomNumberGenerator::init(uint16_t seed) {
	this->seed = seed;
	this->status = Status::WAIT_FOR_ENTROPY_1;
	this->lfsr.init(this->seed);    // initial constant seed
}


void RandomNumberGenerator::onVBlank(BooleanEntropySource &bes) {
	if (this->status == Status::WAIT_FOR_ENTROPY_1) {
		if (bes.getEntropyValue()) {
			this->counter = 0;
			this->status = Status::WAIT_FOR_ENTROPY_2;
		}
	}
	else if (this->status == Status::WAIT_FOR_ENTROPY_2) {
		this->counter++;
		if (bes.getEntropyValue()) {
			this->lfsr.init(this->seed ^ this->counter);    // reset seed
			this->status = Status::IDLE;
		}
	}
}


uint16_t RandomNumberGenerator::getValue() {
	return this->lfsr.getValue();
}

