

#ifndef  __SAVEFILE_H__
#define  __SAVEFILE_H__


#include <stdint.h>
#include "Level.H"


extern "C++" {
	namespace avelino {
		using namespace std;

		class SaveFile {
			public:
				static const uint16_t SIGNATURE_SIZE = 13;
				static const char SIGNATURE[SIGNATURE_SIZE + 1];
				enum class LevelStatus : uint8_t { LOCKED = 0, UNLOCKED = 1, FINISHED = 2 };
				enum class Position : uint16_t { FILE_1 = 1, FILE_2, FILE_3 };
				Position position;
				LevelStatus levels[LevelManager::NUM_LEVELS];
				void init(Position position);
		};

		class SaveFileManager {
			protected:
				uint8_t *getData(SaveFile::Position position);
				uint16_t waitcntBackup;
				void startSRAMAccess();
				void endSRAMAccess();
			public:
				bool isInUse(SaveFile::Position position);
				void init(SaveFile::Position position, SaveFile &file);
				void load(SaveFile::Position position, SaveFile &file);
				void save(SaveFile::Position position, SaveFile &file);
				void remove(SaveFile::Position position);
		};
	}
}


#endif  // __SAVEFILE_H__
