

#ifndef  __SCREEN_H__
#define  __SCREEN_H__


#include <stdint.h>
#include <stddef.h>
#include "Keypad.H"


extern "C++" {
	namespace avelino {
		using namespace std;

		class InterScreenData {   // any data
		};

		class Screen {
			public:
				virtual void onLoad(InterScreenData *dataFromPreviousScreen) = 0;
				virtual Screen *onVBlank(Keypad &keypad) = 0;                              // return "this" to stay on same screen or other screen to switch to
				virtual InterScreenData *onUnload() = 0;
		};

		class ScreenManager {
			public:
				Screen *currentScreen;
				Keypad keypad;
				ScreenManager() : currentScreen(NULL) { };
				void init(Screen &initialScreen, InterScreenData &initialInterScreenData);
				void onVBlank();
		};
	}
}


#endif  // __SCREEN_H__
