

#include "Screen.H"


using namespace std;
using namespace avelino;


void ScreenManager::init(Screen &initialScreen, InterScreenData &initialInterScreenData) {
	this->keypad.init();
	this->currentScreen = &initialScreen;   // start with first screen
	this->currentScreen->onLoad(&initialInterScreenData);
}


void ScreenManager::onVBlank() {
	this->keypad.onVBlank();
	Screen *next = this->currentScreen->onVBlank(this->keypad);
	if (next != this->currentScreen) {    // switch to another screen
		InterScreenData *isd = this->currentScreen->onUnload();   // get data from outgoing screen
		next->onLoad(isd);                                        // and passing it to incomming screen
		this->currentScreen = next;
	}
}

