

#ifndef  __SCREENBOARDSELECTIONMENU_H__
#define  __SCREENBOARDSELECTIONMENU_H__


#include "Screen.H"
#include "Level.H"
#include "TiltManager.H"
#include "PathManager.H"


extern "C++" {
	namespace avelino {
		using namespace std;

		class ScreenBoardSelectionMenu : public Screen, public TiltListener, public PathListener {
			protected:
				InterScreenData *interScreenData;
				enum class Status : uint16_t { WAIT, IDLE };
				Status status;
				static const uint16_t AFTER_INIT_WAIT_COUNTER_MAX = 30;
				static const uint16_t AFTER_KEY_WAIT_COUNTER_MAX = 10;
				uint16_t waitCounter;
				int32_t bg0Offset;
				static const int32_t BG0_OFFSET_INC = ((int32_t) 1) << 15;
				PathManager pathManager;
				int16_t drawText(int16_t x, int16_t y, const char *s);
				class Location {
					public:
						int16_t x, y;
						int16_t upIndex, downIndex;
				};
				static const Location LOCATIONS[LevelManager::NUM_LEVELS + 1];   // last option is the "delete file" option
				uint16_t selectionIndex;   // 0..31 for levels (boards), 32 for the "delete file" option
				void locateSelectionMarker();
				TiltManager tiltManager;
			public:
				virtual void updatePath(PathManager &source, const PathPoint &point);
				virtual void updateTilt(TiltManager &tiltManager, int32_t v);
				Screen *backScreen;
				Screen *deleteFileScreen;
				Screen *boardSelectedScreen;
				virtual void onLoad(InterScreenData *dataFromPreviousScreen);
				virtual Screen *onVBlank(Keypad &keypad);
				virtual InterScreenData *onUnload();
		};
	}
}


#endif  // __SCREENBOARDSELECTIONMENU_H__

