

#include "ScreenConfirmStartBoardMenu.H"
#include "GameStatus.H"


using namespace std;
using namespace avelino;


static char titleText[] = "Ready to start level ??";
static const uint16_t SHORT_NAME_OFFSET = 21;


const char *ScreenConfirmStartBoardMenu::getTitleText(uint16_t index, int16_t &y) {
	if (index == 0) {
		GameStatus *gs = static_cast<GameStatus *>(this->interScreenData);
		if ((gs->currentLevelIndex >= 0) && (gs->currentLevelIndex < LevelManager::NUM_LEVELS)) {
			const Level *level = &LevelManager::LEVELS[gs->currentLevelIndex];
			titleText[SHORT_NAME_OFFSET] = level->shortName[0];
			titleText[SHORT_NAME_OFFSET + 1] = level->shortName[1];
		}
		y = 1;
		return titleText;
	}
	else
		return NULL;
}


static const char BOTTOM_TEXT[] = "Confirm";


const char *ScreenConfirmStartBoardMenu::getBottomText() {
	return BOTTOM_TEXT;
}



Screen *ScreenConfirmStartBoardMenu::optionYesSelected() {
	GameStatus *gs = static_cast<GameStatus *>(this->interScreenData);
	gs->currentLevel = LevelManager::LEVELS[gs->currentLevelIndex];
	gs->timerRunning = false;
	return this->yesScreen;
}


Screen *ScreenConfirmStartBoardMenu::backSelected() {
	return this->backScreen;
}


int16_t ScreenConfirmStartBoardMenu::getMenuStartY() {
	return 5;
}

