

#include "SaveFile.H"
#include "ScreenFileSelectionMenu.H"
#include "GameStatus.H"


using namespace avelino;
using namespace std;


static const char TITLE_TEXT[] = "Choose file";


const char *ScreenFileSelectionMenu::getTitleText(uint16_t index, int16_t &y) {
	if (index == 0) {
		y = 2;
		return TITLE_TEXT;
	}
	else
		return NULL;
}


static const char OPTION_1[] = "File 1";
static const char OPTION_2[] = "File 2";
static const char OPTION_3[] = "File 3";
static const char OPTION_1_IN_USE[] = "File 1 (in use)";
static const char OPTION_2_IN_USE[] = "File 2 (in use)";
static const char OPTION_3_IN_USE[] = "File 3 (in use)";


const char *ScreenFileSelectionMenu::getOptionText(uint16_t index, int16_t &y) {
	SaveFileManager sfm;
	if (index == 0) {
		y = 5;
		return (sfm.isInUse(SaveFile::Position::FILE_1)) ? OPTION_1_IN_USE : OPTION_1;
		//return OPTION_1;
	}
	else if (index == 1) {
		y = 7;
		return (sfm.isInUse(SaveFile::Position::FILE_2)) ? OPTION_2_IN_USE : OPTION_2;
		//return OPTION_2;
	}
	else if (index == 2) {
		y = 9;
		return (sfm.isInUse(SaveFile::Position::FILE_3)) ? OPTION_3_IN_USE : OPTION_3;
		//return OPTION_3;
	}
	else
		return NULL;
}


const char *ScreenFileSelectionMenu::getBottomText() {
	return NULL;
}


Screen *ScreenFileSelectionMenu::optionSelected(uint16_t index) {
	SaveFileManager sfm;
	GameStatus *gameStatus = static_cast<GameStatus *>(this->interScreenData);
	SaveFile::Position position = (index == 0) ? SaveFile::Position::FILE_1 : ((index == 1) ? SaveFile::Position::FILE_2 : SaveFile::Position::FILE_3);
	if (sfm.isInUse(position))
		sfm.load(position, gameStatus->saveFile);
	else
		sfm.init(position, gameStatus->saveFile);
	return this->nextScreen;
}


Screen *ScreenFileSelectionMenu::backSelected() {
	return this->backScreen;
}

