

#ifndef  __SCREENMENU_H__
#define  __SCREENMENU_H__


#include "Screen.H"
#include "TiltManager.H"


extern "C++" {
	namespace avelino {
		using namespace std;

		class ScreenMenu : public Screen, public TiltListener {
			protected:
				static const uint32_t BG0_OFFSET_INC = (1 << 14);
				uint32_t bg0Offset;
				int16_t drawText(int16_t x, int16_t y, const char *s);
				uint16_t currentOptionIndex;
				uint16_t numOptions;
				int16_t optionsX;
				static const uint16_t MAX_OPTIONS = 16;
				int16_t optionsY[MAX_OPTIONS];
				void locateMarker(int16_t x, int16_t y);
				enum class MarkerStatus : uint16_t { STOPED, MOVING_UP, MOVING_DOWN, WAIT };
				MarkerStatus markerStatus;
				InterScreenData *interScreenData;
				static const int32_t MARKER_Y_SPEED_FP = (((int32_t) 3) << 15);
				int32_t markerYFP;
				static const uint16_t INITIAL_WAIT_COUNTER_MAX = 30;
				static const uint16_t AFTER_KEY_WAIT_COUNTER_MAX = 10;
				uint16_t waitCounter;
				static const int32_t MARKER_X_SPEED_FP = (((int32_t) 1) << 14);
				static const int32_t MARKER_X_WIDTH_FP = (((int32_t) 4) << 16);
				int32_t minMarkerXFP;
				int32_t maxMarkerXFP;
				int32_t markerXFP;
				TiltManager tiltManager;
			public:
				virtual void updateTilt(TiltManager &tiltManager, int32_t v);
				virtual void onLoad(InterScreenData *dataFromPreviousScreen);
				virtual Screen *onVBlank(Keypad &keypad);
				virtual InterScreenData *onUnload();
				virtual const char *getTitleText(uint16_t index, int16_t &y) = 0;
				virtual const char *getOptionText(uint16_t index, int16_t &y) = 0;
				virtual const char *getBottomText() = 0;
				virtual Screen *optionSelected(uint16_t index) = 0;
				virtual Screen *backSelected() = 0;
		};
	}
}


#endif  // __SCREENMENU_H__
