

#ifndef  __SECONDSTIMER_H__
#define  __SECONDSTIMER_H__


#include <stdint.h>


extern "C++" {
	namespace avelino {
		using namespace std;

		class SecondsTimer;

		class SecondsTimerListener {
			public:
				virtual void oneSecondElapsed(SecondsTimer &timer) = 0;
		};

		class SecondsTimer {
			protected:
				uint32_t acc;
				SecondsTimerListener *listener;
				static const uint32_t CYCLES_PER_VBLANK = 280896;
				static const uint32_t SYSTEM_CLOCK = (((uint32_t) 16) * 1024 * 1024);
				static const uint32_t FRACTIONAL_BITS = 24;
				uint32_t lastSecond;
				bool stoped;
			public:
				void init(SecondsTimerListener &listener);
				void stop();
				void onVBlank();
		};
	}
}


#endif  // __SECONDSTIMER_H__
