

#ifndef  __TILTMANAGER_H__
#define  __TILTMANAGER_H__


#include <stdint.h>
#include <stdlib.h>


extern "C++" {
	namespace avelino {
		using namespace std;

		class TiltManager;

		class TiltListener {
			public:
				virtual void updateTilt(TiltManager &tiltManager, int32_t v) = 0;
		};

		class TiltManager {
			protected:
				int32_t min, max, speed;
				enum class Status { RESET, RISING, FALLING };
				int32_t v;
				Status status;
				TiltListener *listener;
			public:
				TiltManager() : status(Status::RESET), listener(NULL) { };
				void init(int32_t min, int32_t max, int32_t speed, TiltListener *listener);
				void onVBlank();
		};
	}
}


#endif  // __TILTMANAGER_H__
