

#ifndef  __GBA_H__
#define  __GBA_H__


#include <stdint.h>


#define  SCREEN_WIDTH    240
#define  SCREEN_HEIGHT   160
#define  DISPCNT         *((volatile uint16_t *) 0x04000000)
#define  DISPSTAT        *((volatile uint16_t *) 0x04000004)
#define  MODE0_VRAM       ((uint16_t *) 0x06000000)
#define  MODE3_VRAM_FB    ((uint16_t *) 0x06000000)
#define  OBJ_TILES_VRAM   ((volatile uint16_t *) 0x06014000)
#define  OAM              ((volatile uint16_t *) 0x07000000)
#define  OBJ_PALETTE      ((uint16_t *) 0x05000200)
#define  BLDCNT          *((volatile uint16_t *) 0x04000050)
#define  BLDALPHA        *((volatile uint16_t *) 0x04000052)
#define  BG0CNT          *((volatile uint16_t *) 0x04000008)
#define  BG0HOFS         *((volatile uint16_t *) 0x04000010)
#define  BG0VOFS         *((volatile uint16_t *) 0x04000012)
#define  BG1CNT          *((volatile uint16_t *) 0x0400000A)
#define  BG1HOFS         *((volatile uint16_t *) 0x04000014)
#define  BG1VOFS         *((volatile uint16_t *) 0x04000016)
#define  BG_PALETTE       ((uint16_t *) 0x05000000)
#define  GAMEPAK_SRAM     ((uint8_t *) 0x0E000000)
#define  WAITCNT         *((volatile uint16_t *) 0x04000204)
#define  BG2CNT          *((volatile uint16_t *) 0x0400000C)
#define  BG2HOFS         *((volatile uint16_t *) 0x04000018)
#define  BG2VOFS         *((volatile uint16_t *) 0x0400001A)
#define  BG3CNT          *((volatile uint16_t *) 0x0400000E)
#define  BG3HOFS         *((volatile uint16_t *) 0x0400001C)
#define  BG3VOFS         *((volatile uint16_t *) 0x0400001E)


#define  KEYINPUT        *((volatile uint16_t *) 0x04000130)
#define  KEY_A           ((uint16_t) 1)
#define  KEY_B           ((uint16_t) 2)
#define  KEY_SELECT      ((uint16_t) 4)
#define  KEY_START       ((uint16_t) 8)
#define  KEY_RIGHT       ((uint16_t) 16)
#define  KEY_LEFT        ((uint16_t) 32)
#define  KEY_UP          ((uint16_t) 64)
#define  KEY_DOWN        ((uint16_t) 128)
#define  KEY_R           ((uint16_t) 256)
#define  KEY_L           ((uint16_t) 512)
#define  KEY_PRESSED(k)  (((KEYINPUT & 0x03FF) & (k)) == 0)


#define  RGB555(r, g, b)  ((uint16_t) ((((uint16_t) (r)) & 31) | ((((uint16_t) (g)) & 31) << 5) | ((((uint16_t) (b)) & 31) << 10)))


extern "C++" {
	namespace avelino {
		using namespace std;

		void memcpy16(uint16_t *dest, const uint16_t *source, uint32_t size);
		void memcpy8(uint8_t *dest, const uint8_t *source, uint32_t size);
		void memset16(uint16_t *dest, const uint16_t v, uint32_t size);
		void memset8(uint8_t *dest, const uint8_t v, uint32_t size);
		uint16_t strlen(const char *s);
		bool memequal(const uint8_t *a, const uint8_t *b, uint32_t n);
	}
}


#endif  // __GBA_H__
