#!/bin/bash
convert $1 -format "%[pixel]" _temp.txt
ARRAY_COLS=16
ARRAY_COL=0
N=0
while [ 1 ]; do
	read
	if [ "$?" != "0" ]; then
		break
	fi
	if [ "${REPLY:0:1}" == "#" ]; then
		continue
	fi
	COORDINATES=$( echo "${REPLY}" | cut -d ':' -f 1 )
	X=$( echo "${COORDINATES}" | cut -d ',' -f 1 )
	Y=$( echo "${COORDINATES}" | cut -d ',' -f 2 )
	RGB_TEMP1=$( echo "${REPLY}" | cut -d '(' -f 2 )
	RGB=$( echo "${RGB_TEMP1}" | cut -d ')' -f 1 )
	RED=$( echo "${RGB}" | cut -d ',' -f 1 )
	GREEN=$( echo "${RGB}" | cut -d ',' -f 2 )
	BLUE=$( echo "${RGB}" | cut -d ',' -f 3 )
	RED5=$(( ${RED} / 8 ))
	GREEN5=$(( ${GREEN} / 8 ))
	BLUE5=$(( ${BLUE} / 8 ))
	RGB15=$(( ${RED5} + ( ${GREEN5} * 32 ) + ( ${BLUE5} * 1024 ) ))
	RGB15HEX=$( echo "obase=16;${RGB15}" | bc )
	while [ "${#RGB15HEX}" -lt "4" ]; do
		RGB15HEX="0${RGB15HEX}"
	done
	#echo "${REPLY}   --> X=${X} Y=${Y} R=${RED5} G=${GREEN5} B=${BLUE5} RGB15=${RGB15} (0x${RGB15HEX})"
	if [ "${ARRAY_COL}" -eq "0" ]; then
		echo -en "\t"
	fi
	echo -n "0x${RGB15HEX}, "
	N=$(( ${N} + 1 ))
	ARRAY_COL=$(( ${ARRAY_COL} + 1 ))
	if [ "${ARRAY_COL}" -eq "${ARRAY_COLS}" ]; then
		echo
		ARRAY_COL=0
	fi
done < _temp.txt
echo
echo "// N = ${N}"
rm -f _temp.txt
exit 0
