

#include <stdint.h>
#include "Screen.H"
#include "ScreenAna.H"


using namespace std;
using namespace avelino;


typedef void (*fptr)(void);


#define  ISR_PTR   *((fptr *) 0x03007FFC)
#define  IME       *((volatile uint32_t *) 0x04000208)
#define  IE        *((volatile uint16_t *) 0x04000200)
#define  IF        *((volatile uint16_t *) 0x04000202)
#define  IFBIOS    *((volatile uint16_t *) 0x03007FF8)
#define  DISPSTAT  *((volatile uint16_t *) 0x04000004)


void isr() {
	// mark interrupt as served
	IF = 1;
	IFBIOS |= 1;
}


void enableInterrupts() {
	IME = 0;
	ISR_PTR = isr;
	DISPSTAT = ((uint16_t) 1) << 3;
	IE = 1;   // v-blank
	IME = 1;
}


int main() {
	enableInterrupts();
	ScreenAna screenAna;
	//ScreenManager screenManager;
	//screenManager.init(screenAna);
	screenAna.onLoad(NULL);
	while (true) {
		asm volatile ("swi 0x05");    // wait for v-blank (armv4 instruction set has no "wfi" instruction)
		//screenManager.onVBlank();
		//screenAna.onVBlank();
	}
}
