

#ifndef  __TILES_H__
#define  __TILES_H__


#include <stdint.h>


extern "C++" {
	namespace avelino {
		using namespace std;

		extern const uint16_t OPTION_MARKER_OBJ_TILE[32];
		extern const uint16_t LOCK_OBJ_TILE[32];
		extern const uint16_t DONE_OBJ_TILE[32];

		// board tiles
		const uint16_t NUM_BOARD_TILES = 32;
		const uint16_t BOARD_BORDER_T_TILE_INDEX     = 0;    // flat borders
		const uint16_t BOARD_BORDER_B_TILE_INDEX     = 1;
		const uint16_t BOARD_BORDER_L_TILE_INDEX     = 2;
		const uint16_t BOARD_BORDER_R_TILE_INDEX     = 3;
		const uint16_t BOARD_BORDER_TL_CC_TILE_INDEX = 4;    // concave corners
		const uint16_t BOARD_BORDER_TR_CC_TILE_INDEX = 5;
		const uint16_t BOARD_BORDER_BL_CC_TILE_INDEX = 6;
		const uint16_t BOARD_BORDER_BR_CC_TILE_INDEX = 7;
		const uint16_t BOARD_BORDER_TL_CV_TILE_INDEX = 8;    // convex corners
		const uint16_t BOARD_BORDER_TR_CV_TILE_INDEX = 9;
		const uint16_t BOARD_BORDER_BL_CV_TILE_INDEX = 10;
		const uint16_t BOARD_BORDER_BR_CV_TILE_INDEX = 11;
		const uint16_t BOARD_GRASS_1_TILE_INDEX           = 12;   // grass for right panel (same tile with random decorations)
		const uint16_t BOARD_GRASS_2_TILE_INDEX           = 13;
		const uint16_t BOARD_GRASS_3_TILE_INDEX           = 14;
		const uint16_t BOARD_GRASS_4_TILE_INDEX           = 15;
		const uint16_t BOARD_RED_FINISH_0_TILE_INDEX      = 16;   // red finish
		const uint16_t BOARD_RED_FINISH_1_TILE_INDEX      = 17;
		const uint16_t BOARD_RED_FINISH_2_TILE_INDEX      = 18;
		const uint16_t BOARD_RED_FINISH_3_TILE_INDEX      = 19;
		const uint16_t BOARD_GREEN_FINISH_0_TILE_INDEX    = 20;   // green finish
		const uint16_t BOARD_GREEN_FINISH_1_TILE_INDEX    = 21;
		const uint16_t BOARD_GREEN_FINISH_2_TILE_INDEX    = 22;
		const uint16_t BOARD_GREEN_FINISH_3_TILE_INDEX    = 23;
		const uint16_t BOARD_BLUE_FINISH_0_TILE_INDEX     = 24;   // blue finish
		const uint16_t BOARD_BLUE_FINISH_1_TILE_INDEX     = 25;
		const uint16_t BOARD_BLUE_FINISH_2_TILE_INDEX     = 26;
		const uint16_t BOARD_BLUE_FINISH_3_TILE_INDEX     = 27;
		const uint16_t BOARD_YELLOW_FINISH_0_TILE_INDEX   = 28;   // yellow finish
		const uint16_t BOARD_YELLOW_FINISH_1_TILE_INDEX   = 29;
		const uint16_t BOARD_YELLOW_FINISH_2_TILE_INDEX   = 30;
		const uint16_t BOARD_YELLOW_FINISH_3_TILE_INDEX   = 31;
		extern const uint16_t BOARD_TILES[32 * NUM_BOARD_TILES];
		const uint16_t NUM_BLOCKS = 5;
		const uint16_t TILES_PER_BLOCK = 4;
		const uint16_t NUM_BLOCK_TILES = TILES_PER_BLOCK * NUM_BLOCKS;
		const uint16_t MARKER_BLOCK_TILE_INDEX = 0;
		const uint16_t RED_BLOCK_TILE_INDEX = 1;
		const uint16_t GREEN_BLOCK_TILE_INDEX = 2;
		const uint16_t BLUE_BLOCK_TILE_INDEX = 3;
		const uint16_t YELLOW_BLOCK_TILE_INDEX = 4;
		const uint16_t NUM_ARROW_TILES = 4;
		const uint16_t MARKER_UP_ARROW_TILE_INDEX = 5;
		const uint16_t MARKER_DOWN_ARROW_TILE_INDEX = 6;
		const uint16_t MARKER_LEFT_ARROW_TILE_INDEX = 7;
		const uint16_t MARKER_RIGHT_ARROW_TILE_INDEX = 8;
		extern const uint8_t BLOCK_TILES[64 * (NUM_BLOCK_TILES + NUM_ARROW_TILES)];
	}
}


#endif  // __TILES_H__
